commit 4f9149f5840e824c71776f195a102c1fff431875
Author: Johnn <johnny1991@users.sourceforge.net>
Date:   Thu Dec 17 20:41:39 2020 +0000

    TD-W8970 16M

diff --git a/target/linux/lantiq/base-files/etc/board.d/02_network b/target/linux/lantiq/base-files/etc/board.d/02_network
index a6a9e4d29d..7bbb93e6e0 100755
--- a/target/linux/lantiq/base-files/etc/board.d/02_network
+++ b/target/linux/lantiq/base-files/etc/board.d/02_network
@@ -198,7 +198,7 @@ zyxel,p-2812hnu-f1|zyxel,p-2812hnu-f3)
 		"0:lan" "1:lan" "2:lan" "4:lan" "5:wan" "6t@eth0"
 	;;
 
-tplink,tdw8970|tplink,tdw8980)
+tplink,tdw8970|tplink,tdw8980|tplink,tdw8970-16m)
 	wan_mac=$(macaddr_add "$(mtd_get_mac_binary boardconfig 61696)" 1)
 	ucidef_add_switch "switch0" \
 		"0:lan:2" "2:lan:3" "4:lan:4" "5:lan:1" "6t@eth0"
diff --git a/target/linux/lantiq/base-files/etc/hotplug.d/firmware/12-ath9k-eeprom b/target/linux/lantiq/base-files/etc/hotplug.d/firmware/12-ath9k-eeprom
index 6ae5e3cfe9..4df39a50c8 100644
--- a/target/linux/lantiq/base-files/etc/hotplug.d/firmware/12-ath9k-eeprom
+++ b/target/linux/lantiq/base-files/etc/hotplug.d/firmware/12-ath9k-eeprom
@@ -167,7 +167,7 @@ case "$FIRMWARE" in
 			avm,fritz7412)
 				/usr/bin/fritz_cal_extract -i 1 -s 0x1e000 -e 0x207 -l 4096 -o /lib/firmware/$FIRMWARE $(find_mtd_chardev "urlader")
 				;;
-			tplink,tdw8970|tplink,tdw8980)
+			tplink,tdw8970|tplink,tdw8980|tplink,tdw8970-16m)
 				ath9k_eeprom_extract "boardconfig" 135168 0
 				;;
 			*)
diff --git a/target/linux/lantiq/files-4.14/arch/mips/boot/dts/TDW8970-16M.dts b/target/linux/lantiq/files-4.14/arch/mips/boot/dts/TDW8970-16M.dts
new file mode 100644
index 0000000000..20786a54af
--- /dev/null
+++ b/target/linux/lantiq/files-4.14/arch/mips/boot/dts/TDW8970-16M.dts
@@ -0,0 +1,25 @@
+/dts-v1/;
+
+#include "TDW89X0.dtsi"
+
+/ {
+	compatible = "tplink,tdw8970-16m", "tplink,tdw89x0", "lantiq,xway", "lantiq,vr9";
+	model = "TP-LINK TD-W8970-16M";
+};
+
+&spi {
+    m25p80@4 {
+	partitions {
+	    partition@20000 {
+		reg = <0x20000 0xfa0000>;
+	    };
+	    partition@7c0000 {
+		reg = <0xfc0000 0x10000>;
+	    };
+	    partition@7d0000 {
+		reg = <0xfd0000 0x30000>;
+	    };
+	};
+    };
+};
+
diff --git a/target/linux/lantiq/image/tp-link.mk b/target/linux/lantiq/image/tp-link.mk
index bec9eafbd1..7d93b53420 100644
--- a/target/linux/lantiq/image/tp-link.mk
+++ b/target/linux/lantiq/image/tp-link.mk
@@ -37,6 +37,20 @@ define Device/tplink_tdw8980
 endef
 TARGET_DEVICES += tplink_tdw8980
 
+define Device/tplink_tdw8970-16m
+  $(Device/lantiqTpLink)
+  DEVICE_DTS := TDW8970-16M
+  TPLINK_FLASHLAYOUT := 16Mltq-8Mflsh
+  TPLINK_HWID := 0x89700001
+  TPLINK_HWREV := 1
+  IMAGE_SIZE := 15808k
+  DEVICE_TITLE := TP-LINK TD-W8970-16M
+  DEVICE_PACKAGES:= kmod-ath9k wpad-basic kmod-usb-dwc2 kmod-usb-ledtrig-usbport
+  SUPPORTED_DEVICES += TDW8970-16M
+endef
+TARGET_DEVICES += tplink_tdw8970-16m
+
+
 define Device/tplink_vr200
   $(Device/lantiqTpLink)
   DEVICE_DTS := VR200
diff --git a/tools/firmware-utils/src/mktplinkfw2.c b/tools/firmware-utils/src/mktplinkfw2.c
index 102d72b1cc..1c756ab2a3 100644
--- a/tools/firmware-utils/src/mktplinkfw2.c
+++ b/tools/firmware-utils/src/mktplinkfw2.c
@@ -134,6 +134,12 @@ static struct flash_layout layouts[] = {
 		.kernel_la	= 0x80002000,
 		.kernel_ep	= 0x80002000,
 		.rootfs_ofs	= 0x140000,
+	}, {
+		.id		= "16Mltq-8Mflsh",
+		.fw_max_len	= 0xfae000,
+		.kernel_la	= 0x80002000,
+		.kernel_ep	= 0x80002000,
+		.rootfs_ofs	= 0x140000,
 	}, {
 		.id		= "16Mltq",
 		.fw_max_len	= 0xf90000,
